Educational Codeforces Round 100 (Rated for Div. 2) E. Plan of Lectures 缩点+拓扑排序

E. Plan of Lectures

Ivan is a programming teacher. During the academic year, he plans to give 𝑛 lectures on 𝑛 different topics. Each topic should be used in exactly one lecture. Ivan wants to choose which topic will he explain during the 1-st, 2-nd, ..., 𝑛-th lecture — formally, he wants to choose some permutation of integers from 1 to 𝑛 (let's call this permutation 𝑞). 𝑞𝑖 is the index of the topic Ivan will explain during the 𝑖-th lecture.

For each topic (except exactly one), there exists a prerequisite topic (for the topic 𝑖, the prerequisite topic is 𝑝𝑖). Ivan cannot give a lecture on a topic before giving a lecture on its prerequisite topic. There exists at least one valid ordering of topics according to these prerequisite constraints.

Ordering the topics correctly can help students understand the lectures better. Ivan has 𝑘 special pairs of topics (𝑥𝑖,𝑦𝑖) such that he knows that the students will understand the 𝑦𝑖-th topic better if the lecture on it is conducted right after the lecture on the 𝑥𝑖-th topic. Ivan wants to satisfy the constraints on every such pair, that is, for every 𝑖∈[1,𝑘], there should exist some 𝑗∈[1,𝑛−1] such that 𝑞𝑗=𝑥𝑖 and 𝑞𝑗+1=𝑦𝑖.

Now Ivan wants to know if there exists an ordering of topics that satisfies all these constraints, and if at least one exists, find any of them.

Input

The first line contains two integers 𝑛 and 𝑘 (2≤𝑛≤3⋅105, 1≤𝑘≤𝑛−1) — the number of topics and the number of special pairs of topics, respectively.

The second line contains 𝑛 integers 𝑝1, 𝑝2, ..., 𝑝𝑛 (0≤𝑝𝑖≤𝑛), where 𝑝𝑖 is the prerequisite topic for the topic 𝑖 (or 𝑝𝑖=0 if the 𝑖-th topic has no prerequisite topics). Exactly one of these integers is 0. At least one ordering of topics such that for every 𝑖 the 𝑝𝑖-th topic is placed before the 𝑖-th topic exists.

Then 𝑘 lines follow, the 𝑖-th line contains two integers 𝑥𝑖 and 𝑦𝑖 (1≤𝑥𝑖,𝑦𝑖≤𝑛; 𝑥𝑖≠𝑦𝑖) — the topics from the 𝑖-th special pair. All values of 𝑥𝑖 are pairwise distinct; similarly, all valus of 𝑦𝑖 are pairwise distinct.

Output

If there is no ordering of topics meeting all the constraints, print 0.

Otherwise, print 𝑛 pairwise distinct integers 𝑞1, 𝑞2, ..., 𝑞𝑛 (1≤𝑞𝑖≤𝑛) — the ordering of topics meeting all of the constraints. If there are multiple answers, print any of them.

Examples

input

5 2

2 3 0 5 3

1 5

5 4

output

3 2 1 5 4

题意

有一个人在讲课,会讲n门课。

对于每门课i,他必须在第pi门课讲完后才能讲。其中仅有一门课的pi为0,表示没有需要提前讲的。保证不成环。

现在还有k个强条件,每个条件会给xi,yi。表示讲第xi门课后的下一节课必须讲第yi门课;保证xi!=xj,yi!=yj。

问你是否有合法解,有的话就任意输出一个即可。

题解

首先这道题的题意需要理解一下:

第一个条件相当于给了你一棵树。

第二个条件给了你若干条链或者环,如果存在环直接输出非法即可。(一定是链或者环,因为xi!=xj,yi!=yj,不会有多个点指向同一个点)。

然后这道题因为链里面的点必须强制按照顺序输出,那么我们直接将链进行缩点,然后将树根据缩点后的结果变成一个DAG,然后跑一个拓扑排序直接输出即可。

非法的情况是:强条件中存在环;强条件中顺序和树上顺序冲突;形成的DAG里面有环。

代码

#include<bits/stdc++.h>
using namespace std;
const int maxn = 3e5+7;
vector<int>G[maxn];
int n,k,fa[maxn],nxt[maxn];
int L[maxn],id,rnk[maxn],vis[maxn],rt[maxn],R,ind[maxn];
int main() {
	cin>>n>>k;
	for (int i=1;i<=n;i++) {
		int x;cin>>x;
		fa[i]=x;
		if (x==0) R=i;
	}
	for (int i=1;i<=k;i++) {
		int x,y;
		cin>>x>>y;
		nxt[x]=y;
		vis[y]=1;
	}
	for (int i=1;i<=n;i++) {
		if (vis[i]) continue;
		L[i]=++id;
		int now=0,x=nxt[i];
		rnk[i]=now;
		rt[id]=i;
		while(x!=0&&L[x]==0) {
			L[x]=id;
			rnk[x]=++now;
			x=nxt[x];
		}
	}

	// check circle pass
	for (int i=1;i<=n;i++) {
		if (!L[i]) {
			cout<<"0"<<endl;
			return 0;
		}
		if (L[i]==L[fa[i]]&&rnk[i]<rnk[fa[i]]) {
			cout<<"0"<<endl;
			return 0;
		}
	}

	for (int i=1;i<=n;i++) {
		if (fa[i]==0)continue;
		if (L[fa[i]] != L[i]) {
			G[L[fa[i]]].push_back(L[i]);
			ind[L[i]]++;
		}
	}

	vector<int> ans;
	queue<int> Q;
	for (int i=1;i<=id;i++) {
		if (ind[i]==0) {
			Q.push(i);
		}
	}
	while(!Q.empty()) {
		int now = Q.front();
		Q.pop();
		ans.push_back(now);
		for (int i=0;i<G[now].size();i++) {
			int v = G[now][i];
			ind[v]--;
			if (ind[v]==0) {
				Q.push(v);
			}
		}
	}
	if (ans.size()==id) {
		// for (int i=0;i<ans.size();i++) {
		//     cout<<"---- " << ans[i]<< " " << rt[ans[i]] << endl;
		// }
		for (int i=0;i<ans.size();i++) {
			int now = rt[ans[i]];
			int ID = L[rt[ans[i]]];
			while(now&&ID==L[now]) {
				cout<<now<<" ";
				now=nxt[now];
			}
		}
		cout<<endl;
		return 0;
	}
	cout<<"0"<<endl;
}
posted @ 2020-12-19 01:32  qscqesze  阅读(230)  评论(0编辑  收藏  举报